/* Map2Obj.C
    Converts symbols in an .obj file using
    the output of the corresponding .map file */

#include <stdlib.h>
#include <stdio.h>
#include "map2obj.h"

int main(uint argc, uchar **argv)
{
  uchar *ucpFileName=NULL;
  uchar **ucppStringArray=NULL;
  uchar i;
  uchar ucNumber;

  if (argc!=2)
  {
    printf("Usage: map2obj [file] \n");
    printf("\n");
    printf("Where file is without .map!\n");
    printf("\n");
    printf("The program and its source code my me modified\n");
    printf("as necessary!\n");
    printf("\n");
    printf("Written in 2001 by SStallone\n");
  }
  else
  {
    StringCopy(&ucpFileName, argv[1]);
    AddToString(&ucpFileName, (uchar*) ".map\0");

    ucppStringArray= (uchar**) malloc (200*sizeof(uchar*));
    for (i=0; i<=199; i++)
      ucppStringArray[i]= (uchar*) malloc (100*sizeof(uchar));

    printf("*************************************************************\n");
    printf("Searching Symbols in %s\n", ucpFileName);
    printf("*************************************************************\n");
    if (!SaveSymbolsToArray(ucpFileName, ucppStringArray, &ucNumber))
    {
      printf("Error in creating StringArray!\n");
      exit(EXIT_FAILURE);
    }
    
    printf("\n");
    printf("*************************************************************\n");
    printf("Starting replacing symbols!\n");
    printf("*************************************************************\n");
    StringCopy(&ucpFileName, argv[1]);
    AddToString(&ucpFileName, (uchar*) ".obj\0");
    if (!SaveArrayToFile(ucpFileName, ucppStringArray, ucNumber))
    {
      printf("Error in replacing symbols!\n");
      exit(EXIT_FAILURE);
    }

    for (i=0; i<=199; i++)
      free( (void*) ucppStringArray[i]);
    free( (void*) ucppStringArray);
    free( (void*) ucpFileName);

    printf("All Done!!!\n");
  }
}
